var mjpeg2jpegs = require("mjpeg2jpegs");
var http = require("http");
var fs = require("fs");
var mp4 = require('mp4-mjpeg');
var path = require('path');
var url = require('url');
var timerknock = null;
var stopRecording = true;


// gere le telechargement du MJPEG
// en fonction de l'image rate compose un MP4 au fil de l'eau en filtrant le JPEG
function startRecording(host,imageRate)
{
	stopRecording = false;
	recordingGap =  1000 / imageRate;
	lastDumpedImageTime = 0;
	mp4({ fileName: "timelapse.mp4" })
		.then( (recorder) => 
		{
			image=[];
			imageCounter = 0;
			//recuperation MJPG
			request=http.request(
			{
				hostname: host,
				port : 8080,
				path: "/?action=stream",
			}, 
			
			mjpeg2jpegs( (res) => 
			{
				//on recoit une nouvelle image
				res.on("imageHeader", (header) => 
				{
					console.log("Image header: ", header);
					image=[];
				});
				// concatene les petits bouts d'image
				res.on("imageData", (data) => 
				{
					console.log("Image data: ", data.length);
					image.push(data);
				});
				// imgae est prete
				res.on("imageEnd", () => 
				{       
					var milliseconds = (new Date).getTime();

					// filtrage temporel des images
					if((milliseconds - lastDumpedImageTime) >= recordingGap)
					{
						lastDumpedImageTime = milliseconds;
						//ajoute au MP4
						recorder.appendImageBuffer(Buffer.concat(image));
						//update la preview
						fs.writeFileSync("currentImage.jpg", Buffer.concat(image));
					}
					//time out ou action utlisateur pour arreter
					if(stopRecording == true)
					{
						//stop l'aquisition 
						res.req.abort();
						//ferme le MP4
						recorder.finalize();
					}
				});
		})).end();
		}
	);
}

//Web server
http.createServer(function (request, response) {
	if(request.method == 'GET')
	{
		pathname=url.parse(request.url, true).pathname
		//retourne le status => record en cours ou pas
	    if(pathname ==  '/status')
		{
			response.writeHead(200, { 'Content-Type': 'text/xml' });
			if(stopRecording == true)
			{
				response.end("<status>stopped</status>", 'utf-8');
			}
			else
			{
				response.end("<status>recording</status>", 'utf-8');
			}
		}
		else // retourne les fichiers sur le file system
		{
			var filePath = '.' + pathname;
			var extname = path.extname(filePath);
			var contentType = 'text/html';	
			switch (extname) {
				case '.jpg':
					contentType = 'image/jpg';
					break;
				case '.mp4':
					contentType = 'octet/binary';
					break;
			}
			fs.readFile(filePath, function(error, content) {
				if (error) {
					response.writeHead(500);
					response.end('Sorry, check with the site admin for error: '+error.code+' ..\n');
					response.end(); 
				}
				else {
					response.writeHead(200, { 'Content-Type': contentType });
					response.end(content, 'utf-8');
				}
			});
			
		}
	}//Debute un recording
	else if (request.method == 'POST')
	{
		 var queryData = url.parse(request.url, true).query;
		 startRecording(queryData.host,queryData.imageRate);
		 timerknock=setTimeout(function() {
            stopRecording = true;
         },queryData.duration*1000);
		response.writeHead(200);
		response.end();
	}//arrete le recording
	else if (request.method == 'DELETE')
	{
		clearTimeout(timerknock);
		stopRecording = true;
		response.writeHead(200);
		response.end();
	}
}).listen(80);
console.log('Server running at http://127.0.0.1/index.html');





